#include "mbed.h"


bool LEDs[5][60] = 
{  
//                A             L             -             L         I         G             H             T         I           N              G        .        C             Z         
 { 0,0,0,0,0,  0, 1, 0,  0,  1, 0, 0,  0,  0, 0, 0,  0,  1, 0, 0,  0, 1, 0,  0, 1, 1,  0,  1, 0, 1,  0,  1, 1, 1,  0, 1, 0,  1, 0, 0, 1,  0,  0, 1, 1,  0,0,0,  0, 1, 1,  0,  1, 1, 1,  0,0,0,0 } ,  
 { 0,0,0,0,0,  1, 0, 1,  0,  1, 0, 0,  0,  0, 0, 0,  0,  1, 0, 0,  0, 1, 0,  1, 0, 0,  0,  1, 0, 1,  0,  0, 1, 0,  0, 1, 0,  1, 1, 0, 1,  0,  1, 0, 0,  0,0,0,  1, 0, 0,  0,  0, 0, 1,  0,0,0,0 } ,   
 { 0,0,0,0,0,  1, 1, 1,  0,  1, 0, 0,  0,  1, 1, 1,  0,  1, 0, 0,  0, 1, 0,  1, 1, 1,  0,  1, 1, 1,  0,  0, 1, 0,  0, 1, 0,  1, 0, 1, 1,  0,  1, 1, 1,  0,0,0,  1, 0, 0,  0,  0, 1, 0,  0,0,0,0 } ,
 { 0,0,0,0,0,  1, 0, 1,  0,  1, 0, 0,  0,  0, 0, 0,  0,  1, 0, 0,  0, 1, 0,  1, 0, 1,  0,  1, 0, 1,  0,  0, 1, 0,  0, 1, 0,  1, 0, 0, 1,  0,  1, 0, 1,  0,0,0,  1, 0, 0,  0,  1, 0, 0,  0,0,0,0 } ,
 { 0,0,0,0,0,  1, 0, 1,  0,  1, 1, 1,  0,  0, 0, 0,  0,  1, 1, 1,  0, 1, 0,  0, 1, 0,  0,  1, 0, 1,  0,  0, 1, 0,  0, 1, 0,  1, 0, 0, 1,  0,  0, 1, 0,  0,1,0,  0, 1, 1,  0,  1, 1, 1,  0,0,0,0 } 
};


int main() {   
        int LEDsArraySize = 5;
        int colOffset = 0;  
        int loopCounter = 0; 
          
        //columns set as output
        DigitalOut B0(PTB0); 
        DigitalOut B1(PTB1); 
        DigitalOut B2(PTB2); 
        DigitalOut B3(PTB3);         
        DigitalOut C2(PTC2);
        
        //set rows as output
        DigitalOut C9(PTC9); 
        DigitalOut C8(PTC8); 
        DigitalOut A5(PTA5); 
        DigitalOut A4(PTA4);       
        DigitalOut A12(PTA12);      

        //set all columns False        
        C2=0;
        B3=0;
        B2=0;                
        B1=0;
        B0=0;
                     
        //set all rows False
        C9=0;
        C8=0;
        A5=0;
        A4=0;
        A12=0;
            
    while(1) {
        //speed and running
        if(loopCounter > 40)
        {
            loopCounter = 0;
            colOffset++;
            if(colOffset > sizeof(LEDs[0])-LEDsArraySize)
                colOffset = 0;    
        }
        loopCounter++;
        
        // on-off rows   
        for(int rowIndex=0; rowIndex<LEDsArraySize; rowIndex++)
        {               
            switch (rowIndex)
            {
              case 0:
                    C9=1;
                    C8=0;
                    A5=0;
                    A4=0;
                    A12=0;
                    break;
              case 1:
                    C9=0;
                    C8=1;
                    A5=0;
                    A4=0;
                    A12=0;
                    break;
              case 2:
                    C9=0;
                    C8=0;
                    A5=1;
                    A4=0;
                    A12=0;
                    break;
              case 3:
                    C9=0;
                    C8=0;
                    A5=0;
                    A4=1;
                    A12=0;
                    break;
              case 4:
                    C9=0;
                    C8=0;
                    A5=0;
                    A4=0;
                    A12=1;
                    break;
              default:
                    rowIndex=0;
                    break;
            }   
            
            //on columns
            for(int colIndex=0; colIndex<LEDsArraySize; colIndex++)
            {                  
                bool LED = LEDs[rowIndex][colIndex + colOffset];
                switch (colIndex)
                {
                  case 0:
                        C2=LED; 
                        break;
                  case 1:
                        B3=LED;
                        break;
                  case 2:
                        B2=LED;  
                        break;
                  case 3:       
                        B1=LED;                   
                        break;
                  case 4:
                        B0=LED;                        
                        break;
                  default:
                        colIndex=0;
                        break;
                }  
            }  
            
            //timer
            wait(0.001);
            C2=0;
            B3=0;
            B2=0;                
            B1=0;
            B0=0; 
            C9=0;
            C8=0;
            A5=0;
            A4=0;
            A12=0;
            wait(0.001);       
        }
    }
}
